Horizontal Bimodal in JavaScript

Using ApexCharts with JavaScript

This Horizontal Bimodal example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// ── Reproducible synthetic data (seeded PRNG, no network) ──────────────
function mulberry32(a) {
  return function () {
    a |= 0
    a = (a + 0x6d2b79f5) | 0
    var t = Math.imul(a ^ (a >>> 15), 1 | a)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}
var rng = mulberry32(24681012)

function gauss(mean, sd) {
  var u = 0,
    v = 0
  while (u === 0) u = rng()
  while (v === 0) v = rng()
  return mean + sd * Math.sqrt(-2 * Math.log(u)) * Math.cos(2 * Math.PI * v)
}

// Draw n samples from a mixture of two well-separated normal components — the
// two clusters give each distribution its characteristic twin-hump shape.
function bimodal(n, a, b) {
  var out = []
  for (var i = 0; i < n; i++) {
    var c = rng() < a.w ? a : b
    out.push(Math.max(0, Math.round(gauss(c.mean, c.sd) * 10) / 10))
  }
  return out
}

// Session duration (minutes) per channel — a quick-bounce cluster and an
// engaged-visit cluster, mixed in different proportions.
var CHANNELS = [
  {
    name: 'Direct',
    data: bimodal(320, { w: 0.4, mean: 2, sd: 1 }, { mean: 22, sd: 5 }),
  },
  {
    name: 'Search',
    data: bimodal(320, { w: 0.55, mean: 2, sd: 1 }, { mean: 18, sd: 5 }),
  },
  {
    name: 'Social',
    data: bimodal(320, { w: 0.7, mean: 2, sd: 1 }, { mean: 14, sd: 4 }),
  },
  {
    name: 'Email',
    data: bimodal(320, { w: 0.3, mean: 3, sd: 1.5 }, { mean: 26, sd: 6 }),
  },
]

// Gaussian KDE with a loose bandwidth + coarse step, so the two humps stay
// distinct (a tighter bandwidth would smear them into one) and the outline
// keeps its angular, twin-peaked character.
function kde(values, bw, step) {
  var min = Math.min.apply(null, values) - bw
  var max = Math.max.apply(null, values) + bw
  var N = values.length
  var profile = []
  for (var x = min; x <= max; x += step) {
    var sum = 0
    for (var k = 0; k < N; k++) {
      var d = (x - values[k]) / bw
      sum += Math.exp(-0.5 * d * d)
    }
    profile.push([Math.round(x * 100) / 100, sum / (N * bw)])
  }
  return profile
}

var options = {
  series: [
    {
      name: 'Sessions',
      data: CHANNELS.map(function (c) {
        return {
          x: c.name,
          y: { density: kde(c.data, 2.5, 1.5), points: c.data },
        }
      }),
    },
  ],
  chart: {
    type: 'violin',
    height: 480,
  },
  title: {
    text: 'Session duration by channel',
  },
  plotOptions: {
    bar: {
      horizontal: true,
      distributed: true,
    },
    violin: {
      normalize: 'group',
      points: { show: false }, // density curves only
    },
  },
  colors: ['#0ea5e9', '#F43F5E', '#f97316', '#10b981'],
  stroke: { width: 1, colors: ['#888'] },
  legend: { show: false },
  xaxis: {
    title: { text: 'Session duration (minutes)' },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Horizontal Bimodal in Vue

Using ApexCharts with Vue

This Horizontal Bimodal example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="violin"
        height="480"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// ── Reproducible synthetic data (seeded PRNG, no network) ──────────────
function mulberry32(a) {
  return function () {
    a |= 0
    a = (a + 0x6d2b79f5) | 0
    var t = Math.imul(a ^ (a >>> 15), 1 | a)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}
var rng = mulberry32(24681012)

function gauss(mean, sd) {
  var u = 0,
    v = 0
  while (u === 0) u = rng()
  while (v === 0) v = rng()
  return mean + sd * Math.sqrt(-2 * Math.log(u)) * Math.cos(2 * Math.PI * v)
}

// Draw n samples from a mixture of two well-separated normal components — the
// two clusters give each distribution its characteristic twin-hump shape.
function bimodal(n, a, b) {
  var out = []
  for (var i = 0; i < n; i++) {
    var c = rng() < a.w ? a : b
    out.push(Math.max(0, Math.round(gauss(c.mean, c.sd) * 10) / 10))
  }
  return out
}

// Session duration (minutes) per channel — a quick-bounce cluster and an
// engaged-visit cluster, mixed in different proportions.
var CHANNELS = [
  {
    name: 'Direct',
    data: bimodal(320, { w: 0.4, mean: 2, sd: 1 }, { mean: 22, sd: 5 }),
  },
  {
    name: 'Search',
    data: bimodal(320, { w: 0.55, mean: 2, sd: 1 }, { mean: 18, sd: 5 }),
  },
  {
    name: 'Social',
    data: bimodal(320, { w: 0.7, mean: 2, sd: 1 }, { mean: 14, sd: 4 }),
  },
  {
    name: 'Email',
    data: bimodal(320, { w: 0.3, mean: 3, sd: 1.5 }, { mean: 26, sd: 6 }),
  },
]

// Gaussian KDE with a loose bandwidth + coarse step, so the two humps stay
// distinct (a tighter bandwidth would smear them into one) and the outline
// keeps its angular, twin-peaked character.
function kde(values, bw, step) {
  var min = Math.min.apply(null, values) - bw
  var max = Math.max.apply(null, values) + bw
  var N = values.length
  var profile = []
  for (var x = min; x <= max; x += step) {
    var sum = 0
    for (var k = 0; k < N; k++) {
      var d = (x - values[k]) / bw
      sum += Math.exp(-0.5 * d * d)
    }
    profile.push([Math.round(x * 100) / 100, sum / (N * bw)])
  }
  return profile
}

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Sessions',
          data: CHANNELS.map(function (c) {
            return {
              x: c.name,
              y: { density: kde(c.data, 2.5, 1.5), points: c.data },
            }
          }),
        },
      ],
      chartOptions: {
        chart: {
          type: 'violin',
          height: 480,
        },
        title: {
          text: 'Session duration by channel',
        },
        plotOptions: {
          bar: {
            horizontal: true,
            distributed: true,
          },
          violin: {
            normalize: 'group',
            points: { show: false }, // density curves only
          },
        },
        colors: ['#0ea5e9', '#F43F5E', '#f97316', '#10b981'],
        stroke: { width: 1, colors: ['#888'] },
        legend: { show: false },
        xaxis: {
          title: { text: 'Session duration (minutes)' },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 820px;
  margin: 20px auto;
}
</style>

Horizontal Bimodal in Angular

Using ApexCharts with Angular

This Horizontal Bimodal example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private mulberry32 = (a: any): any => {
          return function () {
            a |= 0
            a = (a + 0x6d2b79f5) | 0
            var t = Math.imul(a ^ (a >>> 15), 1 | a)
            t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
            return ((t ^ (t >>> 14)) >>> 0) / 4294967296
          }
        };

  private rng: any = this.mulberry32(24681012);

  private gauss = (mean: any, sd: any): any => {
          var u = 0,
            v = 0
          while (u === 0) u = this.rng()
          while (v === 0) v = this.rng()
          return mean + sd * Math.sqrt(-2 * Math.log(u)) * Math.cos(2 * Math.PI * v)
        };

  private bimodal = (n: any, a: any, b: any): any => {
          var out = []
          for (var i = 0; i < n; i++) {
            var c = this.rng() < a.w ? a : b
            out.push(Math.max(0, Math.round(this.gauss(c.mean, c.sd) * 10) / 10))
          }
          return out
        };

  private CHANNELS: any = [
          {
            name: 'Direct',
            data: this.bimodal(320, { w: 0.4, mean: 2, sd: 1 }, { mean: 22, sd: 5 }),
          },
          {
            name: 'Search',
            data: this.bimodal(320, { w: 0.55, mean: 2, sd: 1 }, { mean: 18, sd: 5 }),
          },
          {
            name: 'Social',
            data: this.bimodal(320, { w: 0.7, mean: 2, sd: 1 }, { mean: 14, sd: 4 }),
          },
          {
            name: 'Email',
            data: this.bimodal(320, { w: 0.3, mean: 3, sd: 1.5 }, { mean: 26, sd: 6 }),
          },
        ];

  private kde = (values: any, bw: any, step: any): any => {
          var min = Math.min.apply(null, values) - bw
          var max = Math.max.apply(null, values) + bw
          var N = values.length
          var profile = []
          for (var x = min; x <= max; x += step) {
            var sum = 0
            for (var k = 0; k < N; k++) {
              var d = (x - values[k]) / bw
              sum += Math.exp(-0.5 * d * d)
            }
            profile.push([Math.round(x * 100) / 100, sum / (N * bw)])
          }
          return profile
        };

  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Sessions',
              data: this.CHANNELS.map(function (c) {
                return {
                  x: c.name,
                  y: { density: this.kde(c.data, 2.5, 1.5), points: c.data },
                }
              }),
            },
          ],
          chart: {
            type: 'violin',
            height: 480,
          },
          title: {
            text: 'Session duration by channel',
          },
          plotOptions: {
            bar: {
              horizontal: true,
              distributed: true,
            },
            violin: {
              normalize: 'group',
              points: { show: false }, // density curves only
            },
          },
          colors: ['#0ea5e9', '#F43F5E', '#f97316', '#10b981'],
          stroke: { width: 1, colors: ['#888'] },
          legend: { show: false },
          xaxis: {
            title: { text: 'Session duration (minutes)' },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Horizontal Bimodal in React

Using ApexCharts with React

This Horizontal Bimodal example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// ── Reproducible synthetic data (seeded PRNG, no network) ──────────────
function mulberry32(a) {
  return function () {
    a |= 0
    a = (a + 0x6d2b79f5) | 0
    var t = Math.imul(a ^ (a >>> 15), 1 | a)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}
var rng = mulberry32(24681012)

function gauss(mean, sd) {
  var u = 0,
    v = 0
  while (u === 0) u = rng()
  while (v === 0) v = rng()
  return mean + sd * Math.sqrt(-2 * Math.log(u)) * Math.cos(2 * Math.PI * v)
}

// Draw n samples from a mixture of two well-separated normal components — the
// two clusters give each distribution its characteristic twin-hump shape.
function bimodal(n, a, b) {
  var out = []
  for (var i = 0; i < n; i++) {
    var c = rng() < a.w ? a : b
    out.push(Math.max(0, Math.round(gauss(c.mean, c.sd) * 10) / 10))
  }
  return out
}

// Session duration (minutes) per channel — a quick-bounce cluster and an
// engaged-visit cluster, mixed in different proportions.
var CHANNELS = [
  {
    name: 'Direct',
    data: bimodal(320, { w: 0.4, mean: 2, sd: 1 }, { mean: 22, sd: 5 }),
  },
  {
    name: 'Search',
    data: bimodal(320, { w: 0.55, mean: 2, sd: 1 }, { mean: 18, sd: 5 }),
  },
  {
    name: 'Social',
    data: bimodal(320, { w: 0.7, mean: 2, sd: 1 }, { mean: 14, sd: 4 }),
  },
  {
    name: 'Email',
    data: bimodal(320, { w: 0.3, mean: 3, sd: 1.5 }, { mean: 26, sd: 6 }),
  },
]

// Gaussian KDE with a loose bandwidth + coarse step, so the two humps stay
// distinct (a tighter bandwidth would smear them into one) and the outline
// keeps its angular, twin-peaked character.
function kde(values, bw, step) {
  var min = Math.min.apply(null, values) - bw
  var max = Math.max.apply(null, values) + bw
  var N = values.length
  var profile = []
  for (var x = min; x <= max; x += step) {
    var sum = 0
    for (var k = 0; k < N; k++) {
      var d = (x - values[k]) / bw
      sum += Math.exp(-0.5 * d * d)
    }
    profile.push([Math.round(x * 100) / 100, sum / (N * bw)])
  }
  return profile
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Sessions',
        data: CHANNELS.map(function (c) {
          return {
            x: c.name,
            y: { density: kde(c.data, 2.5, 1.5), points: c.data },
          }
        }),
      },
    ],
    options: {
      chart: {
        type: 'violin',
        height: 480,
      },
      title: {
        text: 'Session duration by channel',
      },
      plotOptions: {
        bar: {
          horizontal: true,
          distributed: true,
        },
        violin: {
          normalize: 'group',
          points: { show: false }, // density curves only
        },
      },
      colors: ['#0ea5e9', '#F43F5E', '#f97316', '#10b981'],
      stroke: { width: 1, colors: ['#888'] },
      legend: { show: false },
      xaxis: {
        title: { text: 'Session duration (minutes)' },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="violin"
          height={480}
        />
      </div>
    </div>
  )
}

export default ApexChart